package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.ActuacionesJson;
import com.ejie.ab79.model.EnviosJson;
import com.ejie.ab79.model.InspeccionesJson;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActuacionesJsonDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class ActuacionesJsonDaoImpl implements ActuacionesJsonDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDACTUACIONJSON", "IDACTUACIONMOVIL", "ESTADO",
			"ERROR", "FECHAREGISTRO", "USUARIOREGISTRO", "FECHAULTMODIFICACION", "USUARIOULTMODIFICACION",
			"INSPECJSONIDINSPEC", "INSPECJSONIDINSPEC", "INSPECJSONIDINSPECMOVIL", "INSPECCIONESJSONESTADO",
			"INSPECCIONESJSONERROR", "INSPECJSONFECHAREGISTRO", "INSPECJSONUSUREGISTRO", "INSPECJSONFECHAULTMODIF",
			"INSPECJSONUSULTMODIF", "INSPECJSONIDENVIOJSON" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<ActuacionesJson> rwMap = new RowMapper<ActuacionesJson>() {
		public ActuacionesJson mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new ActuacionesJson(resultSet.getInt("IDACTUACIONJSON"), resultSet.getString("IDACTUACIONMOVIL"),
					resultSet.getInt("ESTADO"), resultSet.getString("ERROR"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"), resultSet.getDate("FECHAULTMODIFICACION"),
					resultSet.getString("USUARIOULTMODIFICACION"),
					new InspeccionesJson(resultSet.getInt("INSPECJSONIDINSPEC"), resultSet.getInt("INSPECJSONIDINSPEC"),
							resultSet.getString("INSPECJSONIDINSPECMOVIL"), resultSet.getInt("INSPECCIONESJSONESTADO"),
							resultSet.getString("INSPECCIONESJSONERROR"), resultSet.getDate("INSPECJSONFECHAREGISTRO"),
							resultSet.getString("INSPECJSONUSUREGISTRO"), resultSet.getDate("INSPECJSONFECHAULTMODIF"),
							resultSet.getString("INSPECJSONUSULTMODIF"),
							new EnviosJson(resultSet.getInt("INSPECJSONIDENVIOJSON"), null, null, null, null, null,
									null, null, null)));
		}
	};

	private RowMapper<ActuacionesJson> rwMapPK = new RowMapper<ActuacionesJson>() {
		public ActuacionesJson mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new ActuacionesJson(resultSet.getInt("IDACTUACIONJSON"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<ActuacionesJson>> rwMapJerarquia = new RowMapper<JerarquiaDto<ActuacionesJson>>() {
		public JerarquiaDto<ActuacionesJson> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			ActuacionesJson actuacionesjson = new ActuacionesJson(resultSet.getInt("ID_ACTUACION_JSON"),
					resultSet.getString("ID_ACTUACION_MOVIL"), resultSet.getInt("ESTADO"), resultSet.getString("ERROR"),
					resultSet.getDate("FECHA_REGISTRO"), resultSet.getString("USUARIO_REGISTRO"),
					resultSet.getDate("FECHA_ULTMODIFICACION"), resultSet.getString("USUARIO_ULTMODIFICACION"),
					new InspeccionesJson(resultSet.getInt("InspeccionesJsonID_INSPECCION_JSON"),
							resultSet.getInt("InspeccionesJsonID_INSPECCION"),
							resultSet.getString("InspeccionesJsonID_INSPECCION_MOVIL"),
							resultSet.getInt("InspeccionesJsonESTADO"), resultSet.getString("InspeccionesJsonERROR"),
							resultSet.getDate("InspeccionesJsonFECHA_REGISTRO"),
							resultSet.getString("InspeccionesJsonUSUARIO_REGISTRO"),
							resultSet.getDate("InspeccionesJsonFECHA_ULTMODIFICACION"),
							resultSet.getString("InspeccionesJsonUSUARIO_ULTMODIFICACION"),
							new EnviosJson(resultSet.getInt("InspeccionesJsonID_ENVIO_JSON"), null, null, null, null,
									null, null, null, null)));

			JerarquiaDto<ActuacionesJson> jerarquia = new JerarquiaDto<ActuacionesJson>();
			jerarquia.setModel(actuacionesjson);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the ActuacionesJson table.
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @return ActuacionesJson
	 */
	@Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = Exception.class)
	public ActuacionesJson add(ActuacionesJson actuacionesjson) {
		int idActuacionesJson = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7938T00.NEXTVAL FROM DUAL",
				Integer.class);
		actuacionesjson.setIdActuacionJson(idActuacionesJson);
		String query = "INSERT INTO ACTUACIONES_JSON (ID_ACTUACION_JSON, ID_INSPECCION_JSON, ID_ACTUACION_MOVIL, ESTADO, ERROR, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,SYSDATE,?)";
		Object getInspeccionesJsonIdInspeccionJsonAux = null;
		if (actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getIdInspeccionJson() != null) {
			getInspeccionesJsonIdInspeccionJsonAux = actuacionesjson.getInspeccionesJson().getIdInspeccionJson();
		}
		this.jdbcTemplate.update(query, idActuacionesJson, getInspeccionesJsonIdInspeccionJsonAux,
				actuacionesjson.getIdActuacionMovil(), actuacionesjson.getEstado(), actuacionesjson.getError(),
				actuacionesjson.getUsuarioRegistro());
		return actuacionesjson;
	}

	/**
	 * Updates a single row in the ActuacionesJson table.
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @return ActuacionesJson
	 */
	@Transactional(propagation = Propagation.REQUIRES_NEW, rollbackFor = Exception.class)
	public ActuacionesJson update(ActuacionesJson actuacionesjson) {
		String query = "UPDATE ACTUACIONES_JSON SET ID_INSPECCION_JSON=?, ID_ACTUACION_MOVIL=?, ESTADO=?, ERROR=?, FECHA_ULTMODIFICACION=SYSDATE, USUARIO_ULTMODIFICACION=? WHERE ID_ACTUACION_JSON=?";
		Object getInspeccionesJsonIdInspeccionJsonAux = null;
		if (actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getIdInspeccionJson() != null) {
			getInspeccionesJsonIdInspeccionJsonAux = actuacionesjson.getInspeccionesJson().getIdInspeccionJson();
		}
		this.jdbcTemplate.update(query, getInspeccionesJsonIdInspeccionJsonAux, actuacionesjson.getIdActuacionMovil(),
				actuacionesjson.getEstado(), actuacionesjson.getError(), actuacionesjson.getUsuarioUltmodificacion(),
				actuacionesjson.getIdActuacionJson());
		return actuacionesjson;
	}

	/**
	 * Finds a single row in the ActuacionesJson table.
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @return ActuacionesJson
	 */
	@Transactional(readOnly = true)
	public ActuacionesJson find(ActuacionesJson actuacionesjson) {
		String query = "SELECT t1.ID_ACTUACION_JSON IDACTUACIONJSON, t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL, t1.ESTADO ESTADO, t1.ERROR ERROR, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t2.ID_INSPECCION_JSON INSPECJSONIDINSPEC, t2.ID_INSPECCION INSPECJSONIDINSPEC, t2.ID_INSPECCION_MOVIL INSPECJSONIDINSPECMOVIL, t2.ESTADO INSPECCIONESJSONESTADO, t2.ERROR INSPECCIONESJSONERROR, t2.FECHA_REGISTRO INSPECJSONFECHAREGISTRO, t2.USUARIO_REGISTRO INSPECJSONUSUREGISTRO, t2.FECHA_ULTMODIFICACION INSPECJSONFECHAULTMODIF, t2.USUARIO_ULTMODIFICACION INSPECJSONUSULTMODIF, t2.ID_ENVIO_JSON INSPECJSONIDENVIOJSON FROM ACTUACIONES_JSON t1 , INSPECCIONES_JSON t2  WHERE t1.ID_ACTUACION_JSON = ?   AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+)";

		List<ActuacionesJson> actuacionesjsonList = this.jdbcTemplate.query(query, this.rwMap,
				actuacionesjson.getIdActuacionJson());
		return (ActuacionesJson) DataAccessUtils.uniqueResult(actuacionesjsonList);
	}

	/**
	 * Removes a single row in the ActuacionesJson table.
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @return
	 */
	public void remove(ActuacionesJson actuacionesjson) {
		String query = "DELETE FROM ACTUACIONES_JSON WHERE ID_ACTUACION_JSON=?";
		this.jdbcTemplate.update(query, actuacionesjson.getIdActuacionJson());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<ActuacionesJson> getMultiple(ActuacionesJson filterActuacionesJson, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterActuacionesJson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, ActuacionesJson.class,
				params, "ID_ACTUACION_JSON");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the ActuacionesJson table.
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<ActuacionesJson>
	 */
	@Transactional(readOnly = true)
	public List<ActuacionesJson> findAll(ActuacionesJson actuacionesjson, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ACTUACION_JSON IDACTUACIONJSON,t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONIDINSPEC,t2.ID_INSPECCION INSPECJSONIDINSPEC,t2.ID_INSPECCION_MOVIL INSPECJSONIDINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECJSONFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECJSONUSUREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECHAULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECJSONUSULTMODIF,t2.ID_ENVIO_JSON INSPECJSONIDENVIOJSON ");
		query.append("FROM ACTUACIONES_JSON t1 ,INSPECCIONES_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(actuacionesjson);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, ActuacionesJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<ActuacionesJson>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the ActuacionesJson table using like.
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ActuacionesJson>
	 */
	@Transactional(readOnly = true)
	public List<ActuacionesJson> findAllLike(ActuacionesJson actuacionesjson, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ACTUACION_JSON IDACTUACIONJSON,t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONIDINSPEC,t2.ID_INSPECCION INSPECJSONIDINSPEC,t2.ID_INSPECCION_MOVIL INSPECJSONIDINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECJSONFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECJSONUSUREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECHAULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECJSONUSULTMODIF,t2.ID_ENVIO_JSON INSPECJSONIDENVIOJSON ");
		query.append("FROM ACTUACIONES_JSON t1 ,INSPECCIONES_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(actuacionesjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, ActuacionesJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<ActuacionesJson>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the ActuacionesJson table.
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(ActuacionesJson actuacionesjson) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ACTUACIONES_JSON t1 , INSPECCIONES_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(actuacionesjson);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the ActuacionesJson table using like.
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(ActuacionesJson actuacionesjson, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ACTUACIONES_JSON t1 ,INSPECCIONES_JSON t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(actuacionesjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of ActuacionesJson selected for rup_table
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActuacionesJson>>
	 */
	@Override
	public List<TableRowDto<ActuacionesJson>> reorderSelection(ActuacionesJson actuacionesjson,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ACTUACION_JSON IDACTUACIONJSON,t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONIDINSPEC,t2.ID_INSPECCION INSPECJSONIDINSPEC,t2.ID_INSPECCION_MOVIL INSPECJSONIDINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECJSONFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECJSONUSUREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECHAULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECJSONUSULTMODIF,t2.ID_ENVIO_JSON INSPECJSONIDENVIOJSON ");
		// FROM
		query.append("FROM ACTUACIONES_JSON t1 ,INSPECCIONES_JSON t2 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(actuacionesjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				ActuacionesJson.class, filterParamList, "ID_ACTUACION_JSON");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<ActuacionesJson>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            ActuacionesJson
	 * @param searchParams
	 *            ActuacionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ActuacionesJson>>
	 */
	@Override
	public List<TableRowDto<ActuacionesJson>> search(ActuacionesJson filterParams, ActuacionesJson searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ACTUACION_JSON IDACTUACIONJSON,t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONIDINSPEC,t2.ID_INSPECCION INSPECJSONIDINSPEC,t2.ID_INSPECCION_MOVIL INSPECJSONIDINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECJSONFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECJSONUSUREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECHAULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECJSONUSULTMODIF,t2.ID_ENVIO_JSON INSPECJSONIDENVIOJSON ");
		// FROM
		query.append("FROM ACTUACIONES_JSON t1 ,INSPECCIONES_JSON t2 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_INSPECCION_JSON= t2.ID_INSPECCION_JSON(+) ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, ActuacionesJson.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_ACTUACION_JSON");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<ActuacionesJson>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filteractuacionesjson
	 *            ActuacionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(ActuacionesJson filteractuacionesjson, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ACTUACION_JSON IDACTUACIONJSON,t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONIDINSPEC,t2.ID_INSPECCION INSPECJSONIDINSPEC,t2.ID_INSPECCION_MOVIL INSPECJSONIDINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECJSONFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECJSONUSUREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECHAULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECJSONUSULTMODIF,t2.ID_ENVIO_JSON INSPECJSONIDENVIOJSON ");
		// FROM
		query.append("FROM ACTUACIONES_JSON t1 ,INSPECCIONES_JSON t2 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filteractuacionesjson, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, ActuacionesJson.class,
				query, params, "ID_ACTUACION_JSON");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical ActuacionesJson table.
	 *
	 * @param filterActuacionesJson
	 *            ActuacionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<ActuacionesJson>>
	 */
	@Override
	public List<JerarquiaDto<ActuacionesJson>> findAllLikeJerarquia(ActuacionesJson filterActuacionesJson,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ACTUACION_JSON IDACTUACIONJSON,t1.ID_ACTUACION_MOVIL IDACTUACIONMOVIL,t1.ESTADO ESTADO,t1.ERROR ERROR,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION,t2.ID_INSPECCION_JSON INSPECJSONIDINSPEC,t2.ID_INSPECCION INSPECJSONIDINSPEC,t2.ID_INSPECCION_MOVIL INSPECJSONIDINSPECMOVIL,t2.ESTADO INSPECCIONESJSONESTADO,t2.ERROR INSPECCIONESJSONERROR,t2.FECHA_REGISTRO INSPECJSONFECHAREGISTRO,t2.USUARIO_REGISTRO INSPECJSONUSUREGISTRO,t2.FECHA_ULTMODIFICACION INSPECJSONFECHAULTMODIF,t2.USUARIO_ULTMODIFICACION INSPECJSONUSULTMODIF,t2.ID_ENVIO_JSON INSPECJSONIDENVIOJSON ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM ACTUACIONES_JSON t1
		// ,INSPECCIONES_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("ACTUACIONES_JSON");
		from.add("INSPECCIONES_JSON");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterActuacionesJson, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_ACTUACION_JSON", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					ActuacionesJsonDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterActuacionesJson
	 *            ActuacionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(ActuacionesJson filterActuacionesJson, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM ACTUACIONES_JSON t1
		// ,INSPECCIONES_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("ACTUACIONES_JSON");
		from.add("INSPECCIONES_JSON");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterActuacionesJson, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_ACTUACION_JSON",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterActuacionesJson
	 *            ActuacionesJson
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<ActuacionesJson>>
	 */
	@Override
	public List<TableRowDto<ActuacionesJson>> findAllChild(ActuacionesJson filterActuacionesJson,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM ACTUACIONES_JSON t1
		// ,INSPECCIONES_JSON t2 ");
		List<String> from = new ArrayList<String>();
		from.add("ACTUACIONES_JSON");
		from.add("INSPECCIONES_JSON");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");
		from_alias.add(" t2 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterActuacionesJson, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_ACTUACION_JSON",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<ActuacionesJson>(this.rwMapPK, "ID_ACTUACION_JSON"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the ActuacionesJson entity
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(ActuacionesJson actuacionesjson) {

		StringBuilder where = new StringBuilder(ActuacionesJsonDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (actuacionesjson != null && actuacionesjson.getIdActuacionJson() != null) {
			where.append(" AND t1.ID_ACTUACION_JSON = ?");
			params.add(actuacionesjson.getIdActuacionJson());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getIdInspeccionJson() != null) {
			where.append(" AND t2.ID_INSPECCION_JSON = ?");
			params.add(actuacionesjson.getInspeccionesJson().getIdInspeccionJson());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getEnviosJson() != null
				&& actuacionesjson.getInspeccionesJson().getEnviosJson().getIdEnvioJson() != null) {
			where.append(" AND t2.ID_ENVIO_JSON = ?");
			params.add(actuacionesjson.getInspeccionesJson().getEnviosJson().getIdEnvioJson());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getIdInspeccion() != null) {
			where.append(" AND t2.ID_INSPECCION = ?");
			params.add(actuacionesjson.getInspeccionesJson().getIdInspeccion());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getIdInspeccionMovil() != null) {
			where.append(" AND t2.ID_INSPECCION_MOVIL = ?");
			params.add(actuacionesjson.getInspeccionesJson().getIdInspeccionMovil());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getEstado() != null) {
			where.append(" AND t2.ESTADO = ?");
			params.add(actuacionesjson.getInspeccionesJson().getEstado());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getError() != null) {
			where.append(" AND t2.ERROR = ?");
			params.add(actuacionesjson.getInspeccionesJson().getError());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getFechaRegistro() != null) {
			where.append(" AND t2.FECHA_REGISTRO = ?");
			params.add(actuacionesjson.getInspeccionesJson().getFechaRegistro());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getUsuarioRegistro() != null) {
			where.append(" AND t2.USUARIO_REGISTRO = ?");
			params.add(actuacionesjson.getInspeccionesJson().getUsuarioRegistro());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getFechaUltmodificacion() != null) {
			where.append(" AND t2.FECHA_ULTMODIFICACION = ?");
			params.add(actuacionesjson.getInspeccionesJson().getFechaUltmodificacion());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getUsuarioUltmodificacion() != null) {
			where.append(" AND t2.USUARIO_ULTMODIFICACION = ?");
			params.add(actuacionesjson.getInspeccionesJson().getUsuarioUltmodificacion());
		}
		if (actuacionesjson != null && actuacionesjson.getIdActuacionMovil() != null) {
			where.append(" AND t1.ID_ACTUACION_MOVIL = ?");
			params.add(actuacionesjson.getIdActuacionMovil());
		}
		if (actuacionesjson != null && actuacionesjson.getEstado() != null) {
			where.append(" AND t1.ESTADO = ?");
			params.add(actuacionesjson.getEstado());
		}
		if (actuacionesjson != null && actuacionesjson.getError() != null) {
			where.append(" AND t1.ERROR = ?");
			params.add(actuacionesjson.getError());
		}
		if (actuacionesjson != null && actuacionesjson.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(actuacionesjson.getFechaRegistro());
		}
		if (actuacionesjson != null && actuacionesjson.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(actuacionesjson.getUsuarioRegistro());
		}
		if (actuacionesjson != null && actuacionesjson.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(actuacionesjson.getFechaUltmodificacion());
		}
		if (actuacionesjson != null && actuacionesjson.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(actuacionesjson.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the ActuacionesJson entity
	 *
	 * @param actuacionesjson
	 *            ActuacionesJson Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(ActuacionesJson actuacionesjson, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ActuacionesJsonDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (actuacionesjson != null && actuacionesjson.getIdActuacionJson() != null) {
			where.append(" AND t1.ID_ACTUACION_JSON = ?");
			params.add(actuacionesjson.getIdActuacionJson());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getIdInspeccionJson() != null) {
			where.append(" AND t2.ID_INSPECCION_JSON = ?");
			params.add(actuacionesjson.getInspeccionesJson().getIdInspeccionJson());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getEnviosJson() != null
				&& actuacionesjson.getInspeccionesJson().getEnviosJson().getIdEnvioJson() != null) {
			where.append(" AND t2.ID_ENVIO_JSON = ?");
			params.add(actuacionesjson.getInspeccionesJson().getEnviosJson().getIdEnvioJson());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getIdInspeccion() != null) {
			where.append(" AND t2.ID_INSPECCION = ?");
			params.add(actuacionesjson.getInspeccionesJson().getIdInspeccion());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getIdInspeccionMovil() != null) {
			where.append(" AND UPPER(t2.ID_INSPECCION_MOVIL) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuacionesjson.getInspeccionesJson().getIdInspeccionMovil().toUpperCase() + "%");
			} else {
				params.add("%" + actuacionesjson.getInspeccionesJson().getIdInspeccionMovil().toUpperCase() + "%");
			}
			where.append(" AND t2.ID_INSPECCION_MOVIL IS NOT NULL");
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getEstado() != null) {
			where.append(" AND t2.ESTADO = ?");
			params.add(actuacionesjson.getInspeccionesJson().getEstado());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getError() != null) {
			where.append(" AND UPPER(t2.ERROR) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuacionesjson.getInspeccionesJson().getError().toUpperCase() + "%");
			} else {
				params.add("%" + actuacionesjson.getInspeccionesJson().getError().toUpperCase() + "%");
			}
			where.append(" AND t2.ERROR IS NOT NULL");
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getFechaRegistro() != null) {
			where.append(" AND t2.FECHA_REGISTRO = ?");
			params.add(actuacionesjson.getInspeccionesJson().getFechaRegistro());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t2.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuacionesjson.getInspeccionesJson().getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + actuacionesjson.getInspeccionesJson().getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t2.USUARIO_REGISTRO IS NOT NULL");
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getFechaUltmodificacion() != null) {
			where.append(" AND t2.FECHA_ULTMODIFICACION = ?");
			params.add(actuacionesjson.getInspeccionesJson().getFechaUltmodificacion());
		}
		if (actuacionesjson != null && actuacionesjson.getInspeccionesJson() != null
				&& actuacionesjson.getInspeccionesJson().getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t2.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuacionesjson.getInspeccionesJson().getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + actuacionesjson.getInspeccionesJson().getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t2.USUARIO_ULTMODIFICACION IS NOT NULL");
		}
		if (actuacionesjson != null && actuacionesjson.getIdActuacionMovil() != null) {
			where.append(" AND UPPER(t1.ID_ACTUACION_MOVIL) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuacionesjson.getIdActuacionMovil().toUpperCase() + "%");
			} else {
				params.add("%" + actuacionesjson.getIdActuacionMovil().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_ACTUACION_MOVIL IS NOT NULL");
		}
		if (actuacionesjson != null && actuacionesjson.getEstado() != null) {
			where.append(" AND t1.ESTADO = ?");
			params.add(actuacionesjson.getEstado());
		}
		if (actuacionesjson != null && actuacionesjson.getError() != null) {
			where.append(" AND UPPER(t1.ERROR) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuacionesjson.getError().toUpperCase() + "%");
			} else {
				params.add("%" + actuacionesjson.getError().toUpperCase() + "%");
			}
			where.append(" AND t1.ERROR IS NOT NULL");
		}
		if (actuacionesjson != null && actuacionesjson.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(actuacionesjson.getFechaRegistro());
		}
		if (actuacionesjson != null && actuacionesjson.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuacionesjson.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + actuacionesjson.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (actuacionesjson != null && actuacionesjson.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(actuacionesjson.getFechaUltmodificacion());
		}
		if (actuacionesjson != null && actuacionesjson.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(actuacionesjson.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + actuacionesjson.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
